#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "layout.h"
#include "obj_draw.h"
#include "draw.h"
#include "obj.h"
#include "emap.h"

#include "xpm/obj/wall.xpm"
#include "xpm/obj/sign.xpm"
#include "xpm/obj/sign_hang.xpm"
#include "xpm/obj/stairs_l.xpm"
#include "xpm/obj/stairs_r.xpm"
#include "xpm/obj/rstairs_l.xpm"
#include "xpm/obj/rstairs_r.xpm"
#include "xpm/obj/slope_l.xpm"
#include "xpm/obj/slope_r.xpm"
#include "xpm/obj/sting_l.xpm"
#include "xpm/obj/sting_r.xpm"
#include "xpm/obj/sting_u.xpm"
#include "xpm/obj/sting_d.xpm"
#include "xpm/obj/pipe.xpm"
#include "xpm/obj/fwall.xpm"

#include "xpm/obj/goal_closed.xpm"
#include "xpm/obj/goal_open1.xpm"
#include "xpm/obj/goal_open2.xpm"
#include "xpm/obj/goal_opened.xpm"
#include "xpm/obj/goal_exit_l1.xpm"
//#include "xpm/obj/goal_exit_l2.xpm"
#include "xpm/obj/goal_exit_l3.xpm"
//#include "xpm/obj/goal_exit_r1.xpm"
#include "xpm/obj/goal_exit_r2.xpm"
//#include "xpm/obj/goal_exit_r3.xpm"

#include "xpm/obj/mswitch_on.xpm"
#include "xpm/obj/mswitch_off.xpm"

#include "xpm/obj/aswitch_on.xpm"
#include "xpm/obj/aswitch_off.xpm"

#include "xpm/obj/teleporter_on.xpm"
#include "xpm/obj/teleporter_off.xpm"

#include "xpm/obj/iwall.xpm"
#include "xpm/obj/iwall_melt0.xpm"
#include "xpm/obj/iwall_melt1.xpm"
#include "xpm/obj/iwall_melt2.xpm"
#include "xpm/obj/iwall_melt3.xpm"
#include "xpm/obj/iwall_melt4.xpm"

#include "xpm/obj/barrier0.xpm"
#include "xpm/obj/barrier1.xpm"
#include "xpm/obj/barrier2.xpm"
#include "xpm/obj/barrier3.xpm"

#include "xpm/obj/gondin.xpm"
#include "xpm/obj/gondin_smash_v1.xpm"
#include "xpm/obj/gondin_smash_v2.xpm"
#include "xpm/obj/gondin_smash_h1.xpm"
#include "xpm/obj/gondin_smash_h2.xpm"
#include "xpm/obj/gondin_burn.xpm"
#include "xpm/obj/gondin_electrocute.xpm"

#include "xpm/obj/chee_walk_l0.xpm"
#include "xpm/obj/chee_walk_l1.xpm"
#include "xpm/obj/chee_walk_r0.xpm"
#include "xpm/obj/chee_walk_r1.xpm"
#include "xpm/obj/chee_smash_vl1.xpm"
#include "xpm/obj/chee_smash_vl2.xpm"
#include "xpm/obj/chee_smash_vr1.xpm"
#include "xpm/obj/chee_smash_vr2.xpm"
#include "xpm/obj/chee_smash_hl1.xpm"
#include "xpm/obj/chee_smash_hl2.xpm"
#include "xpm/obj/chee_smash_hr1.xpm"
#include "xpm/obj/chee_smash_hr2.xpm"
#include "xpm/obj/chee_blast_l.xpm"
#include "xpm/obj/chee_blast_r.xpm"
#include "xpm/obj/chee_pierce_l.xpm"
#include "xpm/obj/chee_pierce_r.xpm"
#include "xpm/obj/chee_burn_l.xpm"
#include "xpm/obj/chee_burn_r.xpm"
#include "xpm/obj/chee_electrocute_l.xpm"
#include "xpm/obj/chee_electrocute_r.xpm"
#include "xpm/obj/chee16_wr0.xpm"
#include "xpm/obj/chee_init.xpm"
#include "xpm/obj/chee_back.xpm"
#include "xpm/obj/chee_eat0.xpm"
#include "xpm/obj/chee_eat1.xpm"
#include "xpm/obj/chee_eat2.xpm"
#include "xpm/obj/chee_eat3.xpm"
#include "xpm/obj/chee_eat4.xpm"
#include "xpm/obj/chee_burp0.xpm"
#include "xpm/obj/chee_burp1.xpm"
#include "xpm/obj/chee_burp2.xpm"
#include "xpm/obj/chee_eat_s0.xpm"
#include "xpm/obj/chee_eat_s1.xpm"
#include "xpm/obj/chee_eat_s2.xpm"
#include "xpm/obj/chee_eat_s3.xpm"
#include "xpm/obj/chee_eat_s4.xpm"
#include "xpm/obj/chee_burp_s0.xpm"
#include "xpm/obj/chee_burp_s1.xpm"
#include "xpm/obj/chee_burp_s2.xpm"
#include "xpm/obj/chee_jump_l.xpm"
#include "xpm/obj/chee_jump_r.xpm"
#include "xpm/obj/chee_flutter_l.xpm"
#include "xpm/obj/chee_flutter_r.xpm"
#include "xpm/obj/chee_ghost_l.xpm"
#include "xpm/obj/chee_ghost_r.xpm"

#include "xpm/obj/chee_bow.xpm"
#include "xpm/obj/chee_wander_r0.xpm"
#include "xpm/obj/chee_wander_r1.xpm"

#include "xpm/obj/hatopo_walk_l0.xpm"
#include "xpm/obj/hatopo_walk_l1.xpm"
#include "xpm/obj/hatopo_walk_r0.xpm"
#include "xpm/obj/hatopo_walk_r1.xpm"
#include "xpm/obj/hatopo_slide_l.xpm"
#include "xpm/obj/hatopo_slide_r.xpm"
#include "xpm/obj/hatopo_smash_hl1.xpm"
#include "xpm/obj/hatopo_smash_hl2.xpm"
#include "xpm/obj/hatopo_smash_hr1.xpm"
#include "xpm/obj/hatopo_smash_hr2.xpm"
#include "xpm/obj/hatopo_smash_vl1.xpm"
#include "xpm/obj/hatopo_smash_vl2.xpm"
#include "xpm/obj/hatopo_smash_vr1.xpm"
#include "xpm/obj/hatopo_smash_vr2.xpm"
#include "xpm/obj/hatopo_blast_l.xpm"
#include "xpm/obj/hatopo_blast_r.xpm"
#include "xpm/obj/hatopo_pierce_l.xpm"
#include "xpm/obj/hatopo_pierce_r.xpm"
#include "xpm/obj/hatopo_burn_l.xpm"
#include "xpm/obj/hatopo_burn_r.xpm"
#include "xpm/obj/hatopo_electrocute_l.xpm"
#include "xpm/obj/hatopo_electrocute_r.xpm"

#include "xpm/obj/gagga_init.xpm"
#include "xpm/obj/gagga_smash_h1.xpm"
#include "xpm/obj/gagga_smash_h2.xpm"
#include "xpm/obj/gagga_smash_v1.xpm"
#include "xpm/obj/gagga_smash_v2.xpm"
#include "xpm/obj/gagga_blast.xpm"
#include "xpm/obj/gagga_pierce.xpm"
#include "xpm/obj/gagga_burn.xpm"
#include "xpm/obj/gagga_electrocute.xpm"
#include "xpm/obj/gagga_attack_l0.xpm"
#include "xpm/obj/gagga_attack_l1.xpm"
#include "xpm/obj/gagga_attack_r0.xpm"
#include "xpm/obj/gagga_attack_r1.xpm"

#include "xpm/obj/gagga_kyupin0.xpm"
#include "xpm/obj/gagga_kyupin1.xpm"

#include "xpm/obj/nya_on_l.xpm"
#include "xpm/obj/nya_on_r.xpm"
#include "xpm/obj/nya_off_l.xpm"
#include "xpm/obj/nya_off_r.xpm"
#include "xpm/obj/nya_halting_l.xpm"
#include "xpm/obj/nya_halting_r.xpm"
#include "xpm/obj/punch_l.xpm"
#include "xpm/obj/punch_r.xpm"

#include "xpm/obj/yaramasi_walk_l0.xpm"
#include "xpm/obj/yaramasi_walk_l1.xpm"
#include "xpm/obj/yaramasi_walk_r0.xpm"
#include "xpm/obj/yaramasi_walk_r1.xpm"
#include "xpm/obj/yaramasi_smash_hl1.xpm"
#include "xpm/obj/yaramasi_smash_hl2.xpm"
#include "xpm/obj/yaramasi_smash_hr1.xpm"
#include "xpm/obj/yaramasi_smash_hr2.xpm"
#include "xpm/obj/yaramasi_smash_vl1.xpm"
#include "xpm/obj/yaramasi_smash_vl2.xpm"
#include "xpm/obj/yaramasi_smash_vr1.xpm"
#include "xpm/obj/yaramasi_smash_vr2.xpm"
#include "xpm/obj/yaramasi_blast_l.xpm"
#include "xpm/obj/yaramasi_blast_r.xpm"
#include "xpm/obj/yaramasi_pierce_l.xpm"
#include "xpm/obj/yaramasi_pierce_r.xpm"
#include "xpm/obj/yaramasi_burn_l.xpm"
#include "xpm/obj/yaramasi_burn_r.xpm"
#include "xpm/obj/yaramasi_electrocute_l.xpm"
#include "xpm/obj/yaramasi_electrocute_r.xpm"

#include "xpm/obj/ojigiri_l.xpm"
#include "xpm/obj/ojigiri_r.xpm"
#include "xpm/obj/ojigiri_smash_vl1.xpm"
#include "xpm/obj/ojigiri_smash_vl2.xpm"
#include "xpm/obj/ojigiri_smash_hl1.xpm"
#include "xpm/obj/ojigiri_smash_hl2.xpm"
#include "xpm/obj/ojigiri_smash_vr1.xpm"
#include "xpm/obj/ojigiri_smash_vr2.xpm"
#include "xpm/obj/ojigiri_smash_hr1.xpm"
#include "xpm/obj/ojigiri_smash_hr2.xpm"
#include "xpm/obj/ojigiri_pierce.xpm"
#include "xpm/obj/ojigiri_burn_l.xpm"
#include "xpm/obj/ojigiri_burn_r.xpm"
#include "xpm/obj/ojigiri_electrocute_l.xpm"
#include "xpm/obj/ojigiri_electrocute_r.xpm"
#include "xpm/obj/ojigiri_eat_l0.xpm"
#include "xpm/obj/ojigiri_eat_l1.xpm"
#include "xpm/obj/ojigiri_eat_l2.xpm"
#include "xpm/obj/ojigiri_eat_r0.xpm"
#include "xpm/obj/ojigiri_eat_r1.xpm"
#include "xpm/obj/ojigiri_eat_r2.xpm"
#include "xpm/obj/ojigiri_digest0.xpm"
#include "xpm/obj/ojigiri_digest1.xpm"

#include "xpm/obj/sue_smash_hl1.xpm"
#include "xpm/obj/sue_smash_hl2.xpm"
#include "xpm/obj/sue_smash_hr1.xpm"
#include "xpm/obj/sue_smash_hr2.xpm"
#include "xpm/obj/sue_smash_vl1.xpm"
#include "xpm/obj/sue_smash_vl2.xpm"
#include "xpm/obj/sue_smash_vr1.xpm"
#include "xpm/obj/sue_smash_vr2.xpm"
#include "xpm/obj/sue_blast_l.xpm"
#include "xpm/obj/sue_blast_r.xpm"
#include "xpm/obj/sue_pierce_l.xpm"
#include "xpm/obj/sue_pierce_r.xpm"
#include "xpm/obj/sue_burn_l.xpm"
#include "xpm/obj/sue_burn_r.xpm"
#include "xpm/obj/sue_electrocute_l.xpm"
#include "xpm/obj/sue_electrocute_r.xpm"
#include "xpm/obj/sue_high_close_l.xpm"
#include "xpm/obj/sue_high_open_l.xpm"
#include "xpm/obj/sue_low_close_l.xpm"
#include "xpm/obj/sue_low_open_l.xpm"
#include "xpm/obj/sue_high_close_r.xpm"
#include "xpm/obj/sue_high_open_r.xpm"
#include "xpm/obj/sue_low_close_r.xpm"
#include "xpm/obj/sue_low_open_r.xpm"

#include "xpm/obj/chu_walk_l0.xpm"
#include "xpm/obj/chu_walk_l1.xpm"
#include "xpm/obj/chu_walk_r0.xpm"
#include "xpm/obj/chu_walk_r1.xpm"
#include "xpm/obj/chu_smash_hl1.xpm"
#include "xpm/obj/chu_smash_hl2.xpm"
#include "xpm/obj/chu_smash_hr1.xpm"
#include "xpm/obj/chu_smash_hr2.xpm"
#include "xpm/obj/chu_smash_vl1.xpm"
#include "xpm/obj/chu_smash_vl2.xpm"
#include "xpm/obj/chu_smash_vr1.xpm"
#include "xpm/obj/chu_smash_vr2.xpm"
#include "xpm/obj/chu_blast_l.xpm"
#include "xpm/obj/chu_blast_r.xpm"
#include "xpm/obj/chu_pierce_l.xpm"
#include "xpm/obj/chu_pierce_r.xpm"
#include "xpm/obj/chu_burn_l.xpm"
#include "xpm/obj/chu_burn_r.xpm"
#include "xpm/obj/chu_electrocute_l.xpm"
#include "xpm/obj/chu_electrocute_r.xpm"
#include "xpm/obj/chu_stand_l0.xpm"
#include "xpm/obj/chu_stand_l1.xpm"
#include "xpm/obj/chu_stand_r0.xpm"
#include "xpm/obj/chu_stand_r1.xpm"
#include "xpm/obj/chu_stand_burn_l.xpm"
#include "xpm/obj/chu_stand_burn_r.xpm"
#include "xpm/obj/chu_stand_electrocute_l.xpm"
#include "xpm/obj/chu_stand_electrocute_r.xpm"
#include "xpm/obj/chu_eating0.xpm"
#include "xpm/obj/chu_eating1.xpm"
#include "xpm/obj/chu_eating2.xpm"
#include "xpm/obj/chu_eating3.xpm"
#include "xpm/obj/chu_eating4.xpm"
#include "xpm/obj/chu_eating5.xpm"
#include "xpm/obj/chu_eating6.xpm"
#include "xpm/obj/chu_eating7.xpm"
#include "xpm/obj/chu_eating8.xpm"
#include "xpm/obj/chu_eating9.xpm"
#include "xpm/obj/chu_eating10.xpm"
#include "xpm/obj/chu_eating11.xpm"
#include "xpm/obj/chu_eating12.xpm"
#include "xpm/obj/chu_eaten_l0.xpm"
#include "xpm/obj/chu_eaten_l1.xpm"
#include "xpm/obj/chu_eaten_l2.xpm"
#include "xpm/obj/chu_eaten_l3.xpm"
#include "xpm/obj/chu_eaten_r0.xpm"
#include "xpm/obj/chu_eaten_r1.xpm"
#include "xpm/obj/chu_eaten_r2.xpm"
#include "xpm/obj/chu_eaten_r3.xpm"
#include "xpm/obj/chu_eating_burn_l.xpm"
#include "xpm/obj/chu_eating_burn_r.xpm"

#include "xpm/obj/jumeme_walk_l0.xpm"
#include "xpm/obj/jumeme_walk_l1.xpm"
#include "xpm/obj/jumeme_walk_r0.xpm"
#include "xpm/obj/jumeme_walk_r1.xpm"
#include "xpm/obj/jumeme_slide_l.xpm"
#include "xpm/obj/jumeme_slide_r.xpm"
#include "xpm/obj/jumeme_smash_hl1.xpm"
#include "xpm/obj/jumeme_smash_hl2.xpm"
#include "xpm/obj/jumeme_smash_hr1.xpm"
#include "xpm/obj/jumeme_smash_hr2.xpm"
#include "xpm/obj/jumeme_smash_vl1.xpm"
#include "xpm/obj/jumeme_smash_vl2.xpm"
#include "xpm/obj/jumeme_smash_vr1.xpm"
#include "xpm/obj/jumeme_smash_vr2.xpm"
#include "xpm/obj/jumeme_blast_l.xpm"
#include "xpm/obj/jumeme_blast_r.xpm"
#include "xpm/obj/jumeme_pierce_l.xpm"
#include "xpm/obj/jumeme_pierce_r.xpm"
#include "xpm/obj/jumeme_wet_l.xpm"
#include "xpm/obj/jumeme_wet_r.xpm"
#include "xpm/obj/jumeme_electrocute_l.xpm"
#include "xpm/obj/jumeme_electrocute_r.xpm"
#include "xpm/obj/jumeme_melt_ul0.xpm"
#include "xpm/obj/jumeme_melt_ur0.xpm"
#include "xpm/obj/jumeme_melt_ul1.xpm"
#include "xpm/obj/jumeme_melt_ur1.xpm"
#include "xpm/obj/jumeme_melt_l0.xpm"
#include "xpm/obj/jumeme_melt_r0.xpm"
#include "xpm/obj/jumeme_melt_l1.xpm"
#include "xpm/obj/jumeme_melt_r1.xpm"
#include "xpm/obj/jumeme_melt_sit0.xpm"
#include "xpm/obj/jumeme_melt_sit1.xpm"

#include "xpm/obj/siguku.xpm"
#include "xpm/obj/siguku_smash_h1.xpm"
#include "xpm/obj/siguku_smash_h2.xpm"
#include "xpm/obj/siguku_blast_l.xpm"
#include "xpm/obj/siguku_blast_r.xpm"
#include "xpm/obj/siguku_splash.xpm"
#include "xpm/obj/siguku_mist.xpm"
#include "xpm/obj/siguku_freezing.xpm"

#include "xpm/obj/mingo_walk_l0.xpm"
#include "xpm/obj/mingo_walk_l1.xpm"
#include "xpm/obj/mingo_walk_l2.xpm"
#include "xpm/obj/mingo_walk_l3.xpm"
#include "xpm/obj/mingo_walk_r0.xpm"
#include "xpm/obj/mingo_walk_r1.xpm"
#include "xpm/obj/mingo_walk_r2.xpm"
#include "xpm/obj/mingo_walk_r3.xpm"
#include "xpm/obj/mingo_slide_l.xpm"
#include "xpm/obj/mingo_slide_r.xpm"
#include "xpm/obj/mingo_smash_vl1.xpm"
#include "xpm/obj/mingo_smash_vl2.xpm"
#include "xpm/obj/mingo_smash_hl1.xpm"
#include "xpm/obj/mingo_smash_hl2.xpm"
#include "xpm/obj/mingo_smash_vr1.xpm"
#include "xpm/obj/mingo_smash_vr2.xpm"
#include "xpm/obj/mingo_smash_hr1.xpm"
#include "xpm/obj/mingo_smash_hr2.xpm"
#include "xpm/obj/mingo_blast_l.xpm"
#include "xpm/obj/mingo_blast_r.xpm"
#include "xpm/obj/mingo_pierce_l.xpm"
#include "xpm/obj/mingo_pierce_r.xpm"
#include "xpm/obj/mingo_burn_l.xpm"
#include "xpm/obj/mingo_burn_r.xpm"
#include "xpm/obj/mingo_electrocute_l.xpm"
#include "xpm/obj/mingo_electrocute_r.xpm"
#include "xpm/obj/mingo_attack_l0.xpm"
#include "xpm/obj/mingo_attack_l1.xpm"
#include "xpm/obj/mingo_attack_r0.xpm"
#include "xpm/obj/mingo_attack_r1.xpm"

#include "xpm/obj/flame_l.xpm"
#include "xpm/obj/flame_r.xpm"
#include "xpm/obj/bone.xpm"
#include "xpm/obj/bang4_4.xpm"
#include "xpm/obj/bang8_4.xpm"
#include "xpm/obj/bang8_8.xpm"
#include "xpm/obj/bang8_16.xpm"
#include "xpm/obj/bang12_8.xpm"


static xpm_info_t xpm_info_list[] = {
	{ii_wall, wall_xpm},
	{ii_sign, sign_xpm},
	{ii_sign_hang, sign_hang_xpm},
    {ii_stairs_l, stairs_l_xpm},
    {ii_stairs_r, stairs_r_xpm},
    {ii_rstairs_l, rstairs_l_xpm},
    {ii_rstairs_r, rstairs_r_xpm},
    {ii_slope_l, slope_l_xpm},
    {ii_slope_r, slope_r_xpm},
	{ii_sting_l, sting_l_xpm},
	{ii_sting_r, sting_r_xpm},
	{ii_sting_u, sting_u_xpm},
	{ii_sting_d, sting_d_xpm},
	{ii_pipe, pipe_xpm},
	{ii_fwall, fwall_xpm},

	{ii_goal_closed, goal_closed_xpm},
	{ii_goal_open1, goal_open1_xpm},
	{ii_goal_open2, goal_open2_xpm},
	{ii_goal_opened, goal_opened_xpm},
	{ii_goal_exit_l1, goal_exit_l1_xpm},
	{ii_goal_exit_r2, goal_exit_r2_xpm},
	{ii_goal_exit_l3, goal_exit_l3_xpm},

	{ii_mswitch_on, mswitch_on_xpm},
	{ii_mswitch_off, mswitch_off_xpm},

	{ii_aswitch_on, aswitch_on_xpm},
	{ii_aswitch_off, aswitch_off_xpm},

	{ii_teleporter_on, teleporter_on_xpm},
	{ii_teleporter_off, teleporter_off_xpm},

	{ii_iwall, iwall_xpm},
	{ii_iwall_melt0, iwall_melt0_xpm},
	{ii_iwall_melt1, iwall_melt1_xpm},
	{ii_iwall_melt2, iwall_melt2_xpm},
	{ii_iwall_melt3, iwall_melt3_xpm},
	{ii_iwall_melt4, iwall_melt4_xpm},

	{ii_barrier0, barrier0_xpm},
	{ii_barrier1, barrier1_xpm},
	{ii_barrier2, barrier2_xpm},
	{ii_barrier3, barrier3_xpm},

    {ii_gondin, gondin_xpm},
    {ii_gondin_smash_v1, gondin_smash_v1_xpm},
    {ii_gondin_smash_v2, gondin_smash_v2_xpm},
    {ii_gondin_smash_h1, gondin_smash_h1_xpm},
    {ii_gondin_smash_h2, gondin_smash_h2_xpm},
    {ii_gondin_burn, gondin_burn_xpm},
    {ii_gondin_electrocute, gondin_electrocute_xpm},

    {ii_chee_walk_l0, chee_walk_l0_xpm},
    {ii_chee_walk_l1, chee_walk_l1_xpm},
    {ii_chee_walk_r0, chee_walk_r0_xpm},
    {ii_chee_walk_r1, chee_walk_r1_xpm},
    {ii_chee_smash_vl1, chee_smash_vl1_xpm},
    {ii_chee_smash_vl2, chee_smash_vl2_xpm},
    {ii_chee_smash_vr1, chee_smash_vr1_xpm},
    {ii_chee_smash_vr2, chee_smash_vr2_xpm},
    {ii_chee_smash_hl1, chee_smash_hl1_xpm},
    {ii_chee_smash_hl2, chee_smash_hl2_xpm},
    {ii_chee_smash_hr1, chee_smash_hr1_xpm},
    {ii_chee_smash_hr2, chee_smash_hr2_xpm},
    {ii_chee_blast_l, chee_blast_l_xpm},
    {ii_chee_blast_r, chee_blast_r_xpm},
    {ii_chee_pierce_l, chee_pierce_l_xpm},
    {ii_chee_pierce_r, chee_pierce_r_xpm},
    {ii_chee_burn_l, chee_burn_l_xpm},
    {ii_chee_burn_r, chee_burn_r_xpm},
    {ii_chee_electrocute_l, chee_electrocute_l_xpm},
    {ii_chee_electrocute_r, chee_electrocute_r_xpm},
    {ii_chee16_wr0, chee16_wr0_xpm},
    {ii_chee_init, chee_init_xpm},
    {ii_chee_back, chee_back_xpm},
    {ii_chee_eat0, chee_eat0_xpm},
    {ii_chee_eat1, chee_eat1_xpm},
    {ii_chee_eat2, chee_eat2_xpm},
    {ii_chee_eat3, chee_eat3_xpm},
    {ii_chee_eat4, chee_eat4_xpm},
    {ii_chee_burp0, chee_burp0_xpm},
    {ii_chee_burp1, chee_burp1_xpm},
    {ii_chee_burp2, chee_burp2_xpm},
    {ii_chee_eat_s0, chee_eat_s0_xpm},
    {ii_chee_eat_s1, chee_eat_s1_xpm},
    {ii_chee_eat_s2, chee_eat_s2_xpm},
    {ii_chee_eat_s3, chee_eat_s3_xpm},
    {ii_chee_eat_s4, chee_eat_s4_xpm},
    {ii_chee_burp_s0, chee_burp_s0_xpm},
    {ii_chee_burp_s1, chee_burp_s1_xpm},
    {ii_chee_burp_s2, chee_burp_s2_xpm},
    {ii_chee_jump_l, chee_jump_l_xpm},
    {ii_chee_jump_r, chee_jump_r_xpm},
    {ii_chee_flutter_l, chee_flutter_l_xpm},
    {ii_chee_flutter_r, chee_flutter_r_xpm},
    {ii_chee_ghost_l0, chee_ghost_l_xpm},
    {ii_chee_ghost_r0, chee_ghost_r_xpm},

    {ii_chee_bow, chee_bow_xpm},
    {ii_chee_wander_r0, chee_wander_r0_xpm},
    {ii_chee_wander_r1, chee_wander_r1_xpm},

    {ii_hatopo_walk_l0, hatopo_walk_l0_xpm},
    {ii_hatopo_walk_l1, hatopo_walk_l1_xpm},
    {ii_hatopo_walk_r0, hatopo_walk_r0_xpm},
    {ii_hatopo_walk_r1, hatopo_walk_r1_xpm},
    {ii_hatopo_slide_l, hatopo_slide_l_xpm},
    {ii_hatopo_slide_r, hatopo_slide_r_xpm},
    {ii_hatopo_smash_vl1, hatopo_smash_vl1_xpm},
    {ii_hatopo_smash_vl2, hatopo_smash_vl2_xpm},
    {ii_hatopo_smash_vr1, hatopo_smash_vr1_xpm},
    {ii_hatopo_smash_vr2, hatopo_smash_vr2_xpm},
    {ii_hatopo_smash_hl1, hatopo_smash_hl1_xpm},
    {ii_hatopo_smash_hl2, hatopo_smash_hl2_xpm},
    {ii_hatopo_smash_hr1, hatopo_smash_hr1_xpm},
    {ii_hatopo_smash_hr2, hatopo_smash_hr2_xpm},
    {ii_hatopo_blast_l, hatopo_blast_l_xpm},
    {ii_hatopo_blast_r, hatopo_blast_r_xpm},
    {ii_hatopo_pierce_l, hatopo_pierce_l_xpm},
    {ii_hatopo_pierce_r, hatopo_pierce_r_xpm},
    {ii_hatopo_burn_l, hatopo_burn_l_xpm},
    {ii_hatopo_burn_r, hatopo_burn_r_xpm},
    {ii_hatopo_electrocute_l, hatopo_electrocute_l_xpm},
    {ii_hatopo_electrocute_r, hatopo_electrocute_r_xpm},

    {ii_gagga_init, gagga_init_xpm},
    {ii_gagga_smash_h1, gagga_smash_h1_xpm},
    {ii_gagga_smash_h2, gagga_smash_h2_xpm},
    {ii_gagga_smash_v1, gagga_smash_v1_xpm},
    {ii_gagga_smash_v2, gagga_smash_v2_xpm},
    {ii_gagga_blast, gagga_blast_xpm},
    {ii_gagga_pierce, gagga_pierce_xpm},
    {ii_gagga_burn, gagga_burn_xpm},
    {ii_gagga_electrocute, gagga_electrocute_xpm},
    {ii_gagga_attack_l0, gagga_attack_l0_xpm},
    {ii_gagga_attack_l1, gagga_attack_l1_xpm},
    {ii_gagga_attack_r0, gagga_attack_r0_xpm},
    {ii_gagga_attack_r1, gagga_attack_r1_xpm},

    {ii_gagga_kyupin0, gagga_kyupin0_xpm},
    {ii_gagga_kyupin1, gagga_kyupin1_xpm},

    {ii_nya_on_l, nya_on_l_xpm},
    {ii_nya_on_r, nya_on_r_xpm},
    {ii_nya_off_l, nya_off_l_xpm},
    {ii_nya_off_r, nya_off_r_xpm},
    {ii_nya_halting_l, nya_halting_l_xpm},
    {ii_nya_halting_r, nya_halting_r_xpm},
    {ii_punch_l, punch_l_xpm},
    {ii_punch_r, punch_r_xpm},

    {ii_yaramasi_walk_l0, yaramasi_walk_l0_xpm},
    {ii_yaramasi_walk_l1, yaramasi_walk_l1_xpm},
    {ii_yaramasi_walk_r0, yaramasi_walk_r0_xpm},
    {ii_yaramasi_walk_r1, yaramasi_walk_r1_xpm},
    {ii_yaramasi_smash_hl1, yaramasi_smash_hl1_xpm},
    {ii_yaramasi_smash_hl2, yaramasi_smash_hl2_xpm},
    {ii_yaramasi_smash_hr1, yaramasi_smash_hr1_xpm},
    {ii_yaramasi_smash_hr2, yaramasi_smash_hr2_xpm},
    {ii_yaramasi_smash_vl1, yaramasi_smash_vl1_xpm},
    {ii_yaramasi_smash_vl2, yaramasi_smash_vl2_xpm},
    {ii_yaramasi_smash_vr1, yaramasi_smash_vr1_xpm},
    {ii_yaramasi_smash_vr2, yaramasi_smash_vr2_xpm},
    {ii_yaramasi_blast_l, yaramasi_blast_l_xpm},
    {ii_yaramasi_blast_r, yaramasi_blast_r_xpm},
    {ii_yaramasi_pierce_l, yaramasi_pierce_l_xpm},
    {ii_yaramasi_pierce_r, yaramasi_pierce_r_xpm},
    {ii_yaramasi_burn_l, yaramasi_burn_l_xpm},
    {ii_yaramasi_burn_r, yaramasi_burn_r_xpm},
    {ii_yaramasi_electrocute_l, yaramasi_electrocute_l_xpm},
    {ii_yaramasi_electrocute_r, yaramasi_electrocute_r_xpm},

    {ii_ojigiri_l, ojigiri_l_xpm},
    {ii_ojigiri_r, ojigiri_r_xpm},
    {ii_ojigiri_smash_vl1, ojigiri_smash_vl1_xpm},
    {ii_ojigiri_smash_vl2, ojigiri_smash_vl2_xpm},
    {ii_ojigiri_smash_hl1, ojigiri_smash_hl1_xpm},
    {ii_ojigiri_smash_hl2, ojigiri_smash_hl2_xpm},
    {ii_ojigiri_smash_vr1, ojigiri_smash_vr1_xpm},
    {ii_ojigiri_smash_vr2, ojigiri_smash_vr2_xpm},
    {ii_ojigiri_smash_hr1, ojigiri_smash_hr1_xpm},
    {ii_ojigiri_smash_hr2, ojigiri_smash_hr2_xpm},
    {ii_ojigiri_pierce, ojigiri_pierce_xpm},
    {ii_ojigiri_burn_l, ojigiri_burn_l_xpm},
    {ii_ojigiri_burn_r, ojigiri_burn_r_xpm},
    {ii_ojigiri_electrocute_l, ojigiri_electrocute_l_xpm},
    {ii_ojigiri_electrocute_r, ojigiri_electrocute_r_xpm},
    {ii_ojigiri_eat_l0, ojigiri_eat_l0_xpm},
    {ii_ojigiri_eat_l1, ojigiri_eat_l1_xpm},
    {ii_ojigiri_eat_l2, ojigiri_eat_l2_xpm},
    {ii_ojigiri_eat_r0, ojigiri_eat_r0_xpm},
    {ii_ojigiri_eat_r1, ojigiri_eat_r1_xpm},
    {ii_ojigiri_eat_r2, ojigiri_eat_r2_xpm},
    {ii_ojigiri_digest0, ojigiri_digest0_xpm},
    {ii_ojigiri_digest1, ojigiri_digest1_xpm},

	{ii_sue_smash_hl1, sue_smash_hl1_xpm},
	{ii_sue_smash_hl2, sue_smash_hl2_xpm},
	{ii_sue_smash_hr1, sue_smash_hr1_xpm},
	{ii_sue_smash_hr2, sue_smash_hr2_xpm},
	{ii_sue_smash_vl1, sue_smash_vl1_xpm},
	{ii_sue_smash_vl2, sue_smash_vl2_xpm},
	{ii_sue_smash_vr1, sue_smash_vr1_xpm},
	{ii_sue_smash_vr2, sue_smash_vr2_xpm},
    {ii_sue_blast_l, sue_blast_l_xpm},
    {ii_sue_blast_r, sue_blast_r_xpm},
	{ii_sue_pierce_l, sue_pierce_l_xpm},
    {ii_sue_pierce_r, sue_pierce_r_xpm},
    {ii_sue_burn_l, sue_burn_l_xpm},
    {ii_sue_burn_r, sue_burn_r_xpm},
    {ii_sue_electrocute_l, sue_electrocute_l_xpm},
    {ii_sue_electrocute_r, sue_electrocute_r_xpm},
	{ii_sue_high_close_l, sue_high_close_l_xpm},
    {ii_sue_high_open_l, sue_high_open_l_xpm},
    {ii_sue_low_close_l, sue_low_close_l_xpm},
    {ii_sue_low_open_l, sue_low_open_l_xpm},
    {ii_sue_high_close_r, sue_high_close_r_xpm},
    {ii_sue_high_open_r, sue_high_open_r_xpm},
    {ii_sue_low_close_r, sue_low_close_r_xpm},
    {ii_sue_low_open_r, sue_low_open_r_xpm},
    
	{ii_chu_walk_l0, chu_walk_l0_xpm},
	{ii_chu_walk_l1, chu_walk_l1_xpm},
	{ii_chu_walk_r0, chu_walk_r0_xpm},
	{ii_chu_walk_r1, chu_walk_r1_xpm},
    {ii_chu_smash_vl1, chu_smash_vl1_xpm},
    {ii_chu_smash_vl2, chu_smash_vl2_xpm},
    {ii_chu_smash_vr1, chu_smash_vr1_xpm},
    {ii_chu_smash_vr2, chu_smash_vr2_xpm},
    {ii_chu_smash_hl1, chu_smash_hl1_xpm},
    {ii_chu_smash_hl2, chu_smash_hl2_xpm},
    {ii_chu_smash_hr1, chu_smash_hr1_xpm},
    {ii_chu_smash_hr2, chu_smash_hr2_xpm},
	{ii_chu_blast_l, chu_blast_l_xpm},
	{ii_chu_blast_r, chu_blast_r_xpm},
	{ii_chu_pierce_l, chu_pierce_l_xpm},
	{ii_chu_pierce_r, chu_pierce_r_xpm},
	{ii_chu_burn_l, chu_burn_l_xpm},
	{ii_chu_burn_r, chu_burn_r_xpm},
    {ii_chu_electrocute_l, chu_electrocute_l_xpm},
    {ii_chu_electrocute_r, chu_electrocute_r_xpm},
	{ii_chu_stand_l0, chu_stand_l0_xpm},
	{ii_chu_stand_l1, chu_stand_l1_xpm},
	{ii_chu_stand_r0, chu_stand_r0_xpm},
	{ii_chu_stand_r1, chu_stand_r1_xpm},
	{ii_chu_stand_burn_l, chu_stand_burn_l_xpm},
	{ii_chu_stand_burn_r, chu_stand_burn_r_xpm},
    {ii_chu_stand_electrocute_l, chu_stand_electrocute_l_xpm},
    {ii_chu_stand_electrocute_r, chu_stand_electrocute_r_xpm},

	{ii_chu_eating0, chu_eating0_xpm},
	{ii_chu_eating1, chu_eating1_xpm},
	{ii_chu_eating2, chu_eating2_xpm},
	{ii_chu_eating3, chu_eating3_xpm},
	{ii_chu_eating4, chu_eating4_xpm},
	{ii_chu_eating5, chu_eating5_xpm},
	{ii_chu_eating6, chu_eating6_xpm},
	{ii_chu_eating7, chu_eating7_xpm},
	{ii_chu_eating8, chu_eating8_xpm},
	{ii_chu_eating9, chu_eating9_xpm},
	{ii_chu_eating10, chu_eating10_xpm},
	{ii_chu_eating11, chu_eating11_xpm},
	{ii_chu_eating12, chu_eating12_xpm},
	{ii_chu_eaten_l0, chu_eaten_l0_xpm},
	{ii_chu_eaten_l1, chu_eaten_l1_xpm},
	{ii_chu_eaten_l2, chu_eaten_l2_xpm},
	{ii_chu_eaten_l3, chu_eaten_l3_xpm},
	{ii_chu_eaten_r0, chu_eaten_r0_xpm},
	{ii_chu_eaten_r1, chu_eaten_r1_xpm},
	{ii_chu_eaten_r2, chu_eaten_r2_xpm},
	{ii_chu_eaten_r3, chu_eaten_r3_xpm},
	{ii_chu_eating_burn_l, chu_eating_burn_l_xpm},
	{ii_chu_eating_burn_r, chu_eating_burn_r_xpm},

    {ii_jumeme_walk_l0, jumeme_walk_l0_xpm},
    {ii_jumeme_walk_l1, jumeme_walk_l1_xpm},
    {ii_jumeme_walk_r0, jumeme_walk_r0_xpm},
    {ii_jumeme_walk_r1, jumeme_walk_r1_xpm},
    {ii_jumeme_slide_l, jumeme_slide_l_xpm},
    {ii_jumeme_slide_r, jumeme_slide_r_xpm},
    {ii_jumeme_smash_vl1, jumeme_smash_vl1_xpm},
    {ii_jumeme_smash_vl2, jumeme_smash_vl2_xpm},
    {ii_jumeme_smash_vr1, jumeme_smash_vr1_xpm},
    {ii_jumeme_smash_vr2, jumeme_smash_vr2_xpm},
    {ii_jumeme_smash_hl1, jumeme_smash_hl1_xpm},
    {ii_jumeme_smash_hl2, jumeme_smash_hl2_xpm},
    {ii_jumeme_smash_hr1, jumeme_smash_hr1_xpm},
    {ii_jumeme_smash_hr2, jumeme_smash_hr2_xpm},
    {ii_jumeme_blast_l, jumeme_blast_l_xpm},
    {ii_jumeme_blast_r, jumeme_blast_r_xpm},
    {ii_jumeme_pierce_l, jumeme_pierce_l_xpm},
    {ii_jumeme_pierce_r, jumeme_pierce_r_xpm},
    {ii_jumeme_wet_l, jumeme_wet_l_xpm},
    {ii_jumeme_wet_r, jumeme_wet_r_xpm},
    {ii_jumeme_electrocute_l, jumeme_electrocute_l_xpm},
    {ii_jumeme_electrocute_r, jumeme_electrocute_r_xpm},
    {ii_jumeme_melt_ul0, jumeme_melt_ul0_xpm},
    {ii_jumeme_melt_ur0, jumeme_melt_ur0_xpm},
    {ii_jumeme_melt_ul1, jumeme_melt_ul1_xpm},
    {ii_jumeme_melt_ur1, jumeme_melt_ur1_xpm},
    {ii_jumeme_melt_l0, jumeme_melt_l0_xpm},
    {ii_jumeme_melt_r0, jumeme_melt_r0_xpm},
    {ii_jumeme_melt_l1, jumeme_melt_l1_xpm},
    {ii_jumeme_melt_r1, jumeme_melt_r1_xpm},
    {ii_jumeme_melt_sit0, jumeme_melt_sit0_xpm},
    {ii_jumeme_melt_sit1, jumeme_melt_sit1_xpm},

	{ii_siguku, siguku_xpm},
    {ii_siguku_splash, siguku_splash_xpm},
    {ii_siguku_mist, siguku_mist_xpm},
    {ii_siguku_smash_h1, siguku_smash_h1_xpm},
    {ii_siguku_smash_h2, siguku_smash_h2_xpm},
    {ii_siguku_blast_l, siguku_blast_l_xpm},
    {ii_siguku_blast_r, siguku_blast_r_xpm},
    {ii_siguku_freezing, siguku_freezing_xpm},

	{ii_mingo_walk_l0, mingo_walk_l0_xpm},
	{ii_mingo_walk_l1, mingo_walk_l1_xpm},
	{ii_mingo_walk_l2, mingo_walk_l2_xpm},
	{ii_mingo_walk_l3, mingo_walk_l3_xpm},
	{ii_mingo_walk_r0, mingo_walk_r0_xpm},
	{ii_mingo_walk_r1, mingo_walk_r1_xpm},
	{ii_mingo_walk_r2, mingo_walk_r2_xpm},
	{ii_mingo_walk_r3, mingo_walk_r3_xpm},
	{ii_mingo_slide_l, mingo_slide_l_xpm},
	{ii_mingo_slide_r, mingo_slide_r_xpm},
    {ii_mingo_smash_vl1, mingo_smash_vl1_xpm},
    {ii_mingo_smash_vl2, mingo_smash_vl2_xpm},
    {ii_mingo_smash_hl1, mingo_smash_hl1_xpm},
    {ii_mingo_smash_hl2, mingo_smash_hl2_xpm},
    {ii_mingo_smash_vr1, mingo_smash_vr1_xpm},
    {ii_mingo_smash_vr2, mingo_smash_vr2_xpm},
    {ii_mingo_smash_hr1, mingo_smash_hr1_xpm},
    {ii_mingo_smash_hr2, mingo_smash_hr2_xpm},
	{ii_mingo_blast_l, mingo_blast_l_xpm},
	{ii_mingo_blast_r, mingo_blast_r_xpm},
	{ii_mingo_pierce_l, mingo_pierce_l_xpm},
	{ii_mingo_pierce_r, mingo_pierce_r_xpm},
	{ii_mingo_burn_l, mingo_burn_l_xpm},
	{ii_mingo_burn_r, mingo_burn_r_xpm},
    {ii_mingo_electrocute_l, mingo_electrocute_l_xpm},
    {ii_mingo_electrocute_r, mingo_electrocute_r_xpm},
	{ii_mingo_attack_l0, mingo_attack_l0_xpm},
	{ii_mingo_attack_l1, mingo_attack_l1_xpm},
	{ii_mingo_attack_r0, mingo_attack_r0_xpm},
	{ii_mingo_attack_r1, mingo_attack_r1_xpm},

	{ii_flame_l, flame_l_xpm},
    {ii_flame_r, flame_r_xpm},
	{ii_bone, bone_xpm},
    {ii_bang4_4, bang4_4_xpm},
    {ii_bang8_4, bang8_4_xpm},
    {ii_bang8_8, bang8_8_xpm},
    {ii_bang8_16, bang8_16_xpm},
    {ii_bang12_8, bang12_8_xpm},
};
#define XPM_INFO_NUM (sizeof(xpm_info_list)/sizeof(xpm_info_t))

type2iid_info_t type2iid_info_list[] = {
    {ot_wall, ii_wall},
    {ot_sign, ii_sign},
    {ot_sign_hang, ii_sign_hang},
    {ot_stairs_l, ii_stairs_l},
    {ot_stairs_r, ii_stairs_r},
    {ot_rstairs_l, ii_rstairs_l},
    {ot_rstairs_r, ii_rstairs_r},
    {ot_slope_l, ii_slope_l},
    {ot_slope_r, ii_slope_r},
    {ot_sting_l, ii_sting_l},
    {ot_sting_r, ii_sting_r},
    {ot_sting_u, ii_sting_u},
    {ot_sting_d, ii_sting_d},


    {ot_fwall, ii_fwall},
    {ot_pipe, ii_pipe},

};
#define TYPE2IID_INFO_NUM \
    (sizeof(type2iid_info_list)/sizeof(type2iid_info_t))
image_id_t type2iid_table[ot_end];
#define Type2Iid(type) (type2iid_table[type])


motion_image_t chee_eat_motions[CHEE_EAT_COUNT][2] = {
	{{ii_chee_init, 0, 0},{ii_chee_init, 0, 0}},
	{{ii_chee_eat0, 0, -8}, {ii_chee_eat_s0, 0, 0}},
    {{ii_chee_eat0, 0, -8}, {ii_chee_eat_s0, 0, 0}},
    {{ii_chee_eat1, 0, -8}, {ii_chee_eat_s1, 0, 0}},
//    {{ii_chee_eat1, 0, -8}, {ii_chee_es1, 0, 0}},
    {{ii_chee_eat2, 0, -8}, {ii_chee_eat_s2, 0, 0}},
    {{ii_chee_eat2, 0, -8}, {ii_chee_eat_s2, 0, 0}},
    {{ii_chee_eat3, 0, -8}, {ii_chee_eat_s3, 0, 0}},
    {{ii_chee_eat3, 0, -8}, {ii_chee_eat_s3, 0, 0}},
    {{ii_chee_eat4, 0, -8}, {ii_chee_eat_s4, 0, 0}},
    {{ii_chee_eat4, 0, -8}, {ii_chee_eat_s4, 0, 0}},
    {{ii_chee_burp0, 0, -8}, {ii_chee_burp_s0, 0, 0}},
    {{ii_chee_burp1, 0, -8}, {ii_chee_burp_s1, 0}},
    {{ii_chee_burp2, 0, -8}, {ii_chee_burp_s2, 0}},
};

motion_image_t chee_exit_motions[CHEE_EXIT_COUNT] = {
	{ii_chee_back, 0, 0},
	{ii_chee_back, 0, 0},
	{ii_chee_back, 0, 0},
	{ii_chee_back, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
	{ii_none, 0, 0},
//	{ii_chee_exit_l1, 0, 0},
//	{ii_chee_exit_l1, 0, 0},
//	{ii_chee_exit_r2, 0, 0},
//	{ii_chee_exit_r2, 0, 0},
//	{ii_chee_exit_l3, 0, 0},
//	{ii_chee_exit_l3, 0, 0},
};

motion_image_t goal_exit_motions[CHEE_EXIT_COUNT] = {
	{ii_goal_opened, 0, 0},
	{ii_goal_opened, 0, 0},
	{ii_goal_opened, 0, 0},
	{ii_goal_opened, 0, 0},
	{ii_goal_exit_l1, 0, 0},
	{ii_goal_exit_l1, 0, 0},
	{ii_goal_exit_r2, 0, 0},
	{ii_goal_exit_r2, 0, 0},
	{ii_goal_exit_l3, 0, 0},
	{ii_goal_exit_l3, 0, 0},
};


motion_image_t ojigiri_eat_motions[OJIGIRI_EAT_COUNT][2] = {
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l1, -8, 8}, {ii_ojigiri_eat_r1, 0, 8}},
	{{ii_ojigiri_eat_l1, -8, 8}, {ii_ojigiri_eat_r1, 0, 8}},
	{{ii_ojigiri_eat_l1, -8, 8}, {ii_ojigiri_eat_r1, 0, 8}},
	{{ii_ojigiri_eat_l2,  0, 0}, {ii_ojigiri_eat_r2, 0, }},
	{{ii_ojigiri_eat_l2,  0, 0}, {ii_ojigiri_eat_r2, 0, 0}},
	{{ii_ojigiri_eat_l2,  0, 0}, {ii_ojigiri_eat_r2,  0, 0}},
};

motion_image_t ojigiri_vomit_motions[OJIGIRI_VOMIT_COUNT][2] = {
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_eat_l1, -8, 8}, {ii_ojigiri_eat_r1, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l0, -8, 8}, {ii_ojigiri_eat_r0, 0, 8}},
	{{ii_ojigiri_eat_l1, -8, 8}, {ii_ojigiri_eat_r1, 0, 8}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
	{{ii_ojigiri_l,    0, 0}, {ii_ojigiri_r,   0, 0}},
};

motion_image_t gagga_hit_motions[GAGGA_HIT_COUNT][2] = {
	{{ii_gagga_attack_l0, 0, 0}, {ii_gagga_attack_r0, 0, 0}},
	{{ii_gagga_attack_l0, 0, 0}, {ii_gagga_attack_r0, 0, 0}},
//	{{ii_gagga_attack_l0, 0, 0}, {ii_gagga_attack_r0, 0, 0}},
//	{{ii_gagga_attack_l0, 0, 0}, {ii_gagga_attack_r0, 0, 0}},
	{{ii_gagga_attack_l1, -4, 0}, {ii_gagga_attack_r1, 0, 0}},
	{{ii_gagga_attack_l1, -4, 0}, {ii_gagga_attack_r1, 0, 0}},
	{{ii_gagga_attack_l1, -4, 0}, {ii_gagga_attack_r1, 0, 0}},
	{{ii_gagga_attack_l1, -4, 0}, {ii_gagga_attack_r1, 0, 0}},
	{{ii_gagga_attack_l1, -4, 0}, {ii_gagga_attack_r1, 0, 0}},
	{{ii_gagga_attack_l1, -4, 0}, {ii_gagga_attack_r1, 0, 0}},
};


motion_image_t chu_eat_motions[CHU_EAT_COUNT][2] = {
    // 元のごんでぃんは1フレーム経たないと消えない
	{{ii_none,         0,  0}, {ii_none,         0,  0}}, 

	{{ii_chu_eating0,  0,  0}, {ii_chu_eating0,  0,  0}},
	{{ii_chu_eating1,  0,  0}, {ii_chu_eating1,  0,  0}},
	{{ii_chu_eating2,  0,  0}, {ii_chu_eating2,  0,  0}},
	{{ii_chu_eating3,  0,  0}, {ii_chu_eating3,  0,  0}},
	{{ii_chu_eating4,  0,  0}, {ii_chu_eating4,  0,  0}},
	{{ii_chu_eating5,  0,  0}, {ii_chu_eating5,  0,  0}},
	{{ii_chu_eating6,  0,  0}, {ii_chu_eating6,  0,  0}},
	{{ii_chu_eating7,  0,  0}, {ii_chu_eating7,  0,  0}},
	{{ii_chu_eating8,  0,  0}, {ii_chu_eating8,  0,  0}},
	{{ii_chu_eating9,  0, -5}, {ii_chu_eating9,  0, -5}},
	{{ii_chu_eating10, 0, -5}, {ii_chu_eating10, 0, -5}},
	{{ii_chu_eating11, 0, -5}, {ii_chu_eating11, 0, -5}},
	{{ii_chu_eating11, 0, -5}, {ii_chu_eating11, 0, -5}},
	{{ii_chu_eating12, 0, -5}, {ii_chu_eating12, 0, -5}},
	{{ii_chu_eating12, 0, -5}, {ii_chu_eating12, 0, -5}},
	{{ii_chu_eaten_l0, 0, -5}, {ii_chu_eaten_l0, 0, -5}},
	{{ii_chu_eaten_l0, 0, -5}, {ii_chu_eaten_l0, 0, -5}},
	{{ii_chu_eaten_l1, 0, -5}, {ii_chu_eaten_l1, 0, -5}},
	{{ii_chu_eaten_l1, 0, -5}, {ii_chu_eaten_l1, 0, -5}},
	{{ii_chu_eaten_l2, 0, -5}, {ii_chu_eaten_l2, 0, -5}},
	{{ii_chu_eaten_l2, 0, -5}, {ii_chu_eaten_l2, 0, -5}},
	{{ii_chu_eaten_l3, 0, -5}, {ii_chu_eaten_l3, 0, -5}},
	{{ii_chu_eaten_l3, 0, -5}, {ii_chu_eaten_l3, 0, -5}},
};

motion_image_t iwall_melt_motions[IWALL_LIFE] = {
    {ii_iwall, 0, 0},
    {ii_iwall_melt0, 0, 0},
    {ii_iwall_melt1, 0, 0},
    {ii_iwall_melt2, 0, 0},
    {ii_iwall_melt3, 0, 0},
    {ii_iwall_melt4, 0, 0},
};

#define DefaultCreatureDraws   \
    case os_teleporting:       \
        draw_teleporting(obj); \
        break;                 \
    case os_dead:			   \
		break;                 \
	default:                   \
        draw_motion(obj);      \
        break;                 \
 

static EzImage imgs[ii_end];

void obj_draw_init(void){
    int i;
    for (i = 0 ; i < XPM_INFO_NUM ; i++){
        imgs[xpm_info_list[i].iid] = EzReadXPM(xpm_info_list[i].xpm);
    }
    for (i = 0 ; i < TYPE2IID_INFO_NUM ; i++){
        type2iid_table[type2iid_info_list[i].type] 
            = type2iid_info_list[i].iid;
    }
}

void draw_img(image_id_t iid, int x, int y){
    DrawImg(x, y, imgs[iid]);
}

int draw_motion(obj_t *obj){
    if (obj->motion != ii_none){
        draw_img(obj->motion, obj->x, obj->y);
    }
    return 0;
}

int draw_creature(obj_t *obj){
    switch (State(obj)){
        DefaultCreatureDraws
    }
    return 0;
}


void draw_teleporting(obj_t *obj){
    int lx, rx, y, i;
	int dx, dy;
	obj_t *teleporter = obj->link;

    SetColor(6);

	draw_motion(obj);
    // グリッド単位ではなくピクセル単位でエフェクトを描くから、DrawLine等は使えない
    // グリッド座標だけDLTX/DLTYで座標変換して直接Ez関数を呼び出す
    lx = DLTX(Ltx(obj));
    rx = DRBX(Rbx(obj));
    y = DLTX(Lty(obj));
    for (i = 0 ; i < DScale(obj->height) ; i+=2){
	    EzDrawLineB(lx, y+i, rx, y+i);
	}
    //    SetColor(0);
	EzFillBoxB(lx, y, rx, y+(Ctr(obj)<<1));
    printf("teleport ctr=%d ry=%d\n", Ctr(obj), (Ctr(obj)<<1));

 	dx = teleporter->link->x + obj->x - Ltx(teleporter);
	dy = teleporter->link->y + obj->y - (Lby(teleporter)+1);	
	if (obj->motion != ii_none){
        draw_img(obj->motion, dx, dy);
    }
	lx = DLTX(dx);
    rx = DRBX(dx+obj->width-1);
    //	rx = lx + DScale(obj->width);
	y = DLTY(dy);
    for (i = (Ctr(obj)<<1)+1 ; i < DScale(obj->height) ; i+=2){
	    EzDrawLineB(lx, y+i, rx, y+i);
	}
}

int draw_fwall(obj_t *obj){
    if (IsAlive(obj)){
	    draw_img(ii_fwall, obj->x, obj->y);
    }
    else {
        draw_img(ii_fwall, obj->x, obj->y);
    }
    return 0;
}
int draw_iwall(obj_t *obj){
    assert(Ctr(obj) < IWALL_LIFE);
    draw_img(iwall_melt_motions[Ctr(obj)].iid, obj->x, obj->y);
    /*

    if (IsAlive(obj)){
	    draw_img(ii_iwall, obj->x, obj->y);
    }
    else {
	    draw_img(ii_iwall, obj->x, obj->y);
    }
    */
    return 0;
}

int draw_chee(obj_t *obj){
	motion_image_t mi;

    switch (State(obj)){
    case os_chee_eating:
        if (check_emap_box_any(Ltx(obj), Lty(obj)-7, obj->width, obj->height,
                               EM_BLOCK_UP))
        {
            mi = chee_eat_motions[Ctr(obj)][1];
        }
        else {
            mi = chee_eat_motions[Ctr(obj)][0];
        }
		draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        break;
    case os_exit:
		mi = chee_exit_motions[Ctr(obj)];
        if (mi.iid != ii_none){
            draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        }
        break;
    case os_teleporting:
		draw_teleporting(obj);
        break;
    default:
        draw_motion(obj);
        break;
    }
    return 0;
}

int post_draw_ojigiri(obj_t *obj){
	int dirix, bx, by, offset = 0;
	motion_image_t mi;
    switch (State(obj)){
    case os_eating:
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = ojigiri_eat_motions[Ctr(obj)][dirix];
        draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        break;
    case os_vomitting:
        if (Ctr(obj) > 1){
            if (Ctr(obj) < 5){
                offset = 5 - Ctr(obj);
            }
            bx = (obj->dir == di_left) ?
                Ltx(obj)-8+offset : Rtx(obj)+4-offset;
            by = Rby(obj) - 3 - offset;
            draw_img(ii_bone, bx, by);
        }
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = ojigiri_vomit_motions[Ctr(obj)][dirix];
        draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        break;
    case os_teleporting:
		draw_teleporting(obj);
        break;
    default:
        draw_img(obj->motion, obj->x, obj->y);
        break;
    }
    return 0;
}

int draw_goal(obj_t *obj){
	motion_image_t mi;
    switch (State(obj)){
	case os_exit:
		mi = goal_exit_motions[Ctr(obj)];
		draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
		break;
	default:
        draw_motion(obj);
		break;
	}
	return 0;
}

int draw_gagga(obj_t *obj){
	dir_t dirix;
	motion_image_t mi;

	switch(State(obj)){
	case os_blast:
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = gagga_hit_motions[Ctr(obj)][dirix];
        draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
		break;
    DefaultCreatureDraws
	}
    return 0;
}

int post_draw_gagga(obj_t *obj){
	if (State(obj) == os_blast && Ctr(obj) > GAGGA_BLAST_COUNT){
		if (obj->dir == di_left){
	        draw_img(ii_bang8_8, Ltx(obj)-3-8, Lty(obj));
		}
		else {
	        draw_img(ii_bang8_8, Rtx(obj)+4, Lty(obj));
		}
	}
	return 0;
}

int draw_nya(obj_t *obj){
    int lx, rx;
    obj_t *punch = obj->link;
	// にゃあとパンチの重ね合せ順を固定するため、ここでパンチもまとめて描画
    // 最初に腕を描画してはみ出した分をパンチとにゃあに隠す
	SetColor(7);
    if (obj->dir == di_left){
        lx = punch->x + punch->width/2;
        rx = obj->x + obj->width/2;
    }
    else {
        lx = obj->x + obj->width/2;
        rx = punch->x + punch->width/2;
    }
    //    if (State(obj) != os_off){
    if (rx-lx > 0){
        EzFillBoxB(DLTX(lx), DLTY(obj->y+8+1)+2, 
                   DRBX(rx), DLTY(obj->y+8+1)+2+3);
        draw_img(punch->motion, Ltx(punch), Lty(punch));
    }
        draw_img(obj->motion, obj->x, obj->y);
    return 0;
}

int draw_punch(obj_t *obj){
	// にゃあのところで描画するので、ここは空にしておく
    return 0;
}

int draw_chu(obj_t *obj){
	motion_image_t mi;
	int dirix;

	switch (State(obj)){
    case os_eating:
		dirix = (obj->dir == di_left) ? 0 : 1;
		mi = chu_eat_motions[Ctr(obj)][dirix];
        if (mi.iid != ii_none){
            draw_img(mi.iid, obj->x+mi.xoffset, obj->y+mi.yoffset);
        }
        break;
    DefaultCreatureDraws
	}
    return 0;
}

// 状態により表示位置をずらすのでdraw_creatureではなく専用関数
int draw_jumeme(obj_t *obj){
//    image_id_t iid;
    
	switch (State(obj)){
    case os_jumeme_melting_upper:
//        iid = (obj->dir == di_left) ? ii_fire_melt_ul0 : ii_fire_melt_ur0;
        draw_img(obj->motion , obj->x, obj->y-1);
        break;
    DefaultCreatureDraws
	}
    return 0;
}

int draw_flame(obj_t *obj){
    switch (State(obj)){
    case os_teleporting:       
        draw_teleporting(obj); 
        break;
	default:
        draw_motion(obj);
        break;
	}
	return 0;
}

int draw_static(obj_t *obj){
    draw_img(Type2Iid(obj->type), obj->x, obj->y);
    return 0;
}

void draw_wall(obj_t *obj){
    //    DrawImg(obj->x, obj->y, img_wall);
    /*
    int x, y, w, h;
    x = obj->x;
    y = obj->y;
    w = obj->width;
    h = obj->height;
        printf("draw wall(%d, %d)\n", x, y);
    SetColor(2);
    DrawFillBox(x, y, w, h);
    SetColor(0);
    EzDrawLineB(DLTX(x), DLTY(y), DRBX(x+w-1), DLTY(y));
    EzDrawLineB(DLTX(x), DLTY(y+h/2), DRBX(x+w-1), DLTY(y+h/2));
    EzDrawLineB(DLTX(x+w/4), DLTY(y), DLTX(x+w/4), DLTY(y+h/2));
    EzDrawLineB(DLTX(x+w*3/4), DLTY(y+h/2), DLTX(x+w*3/4), DRBY(y+h-1));
    */
}
int draw_lift(obj_t *obj){
    int x, y, w, h;
    x = obj->x;
    y = obj->y;
    w = obj->width;
    h = obj->height;
    SetColor(4);
    DrawFillBox(x, y, w, h);
    return 0;
}

int draw_switch(obj_t *obj){
	int x;
	for (x = Ltx(obj) ; x < Rtx(obj) ; x+=GRID_SIZE){
	    draw_img(obj->motion, x, obj->y);
	}
	return 0;
}

int draw_teleporter(obj_t *obj){
	int x;
	for (x = Ltx(obj) ; x < Rtx(obj) ; x+=GRID_SIZE){
	    draw_img(obj->motion, x, obj->y);
	}
	return 0;
}

int draw_barrier(obj_t *obj){
	int x, y;
    //    printf("draw barrier(%d, %d) %d (%d, %d)(%d, %d)\n", obj->width, obj->height, obj->motion, Ltx(obj), Rbx(obj), Lty(obj), Rby(obj));
    //    printf("draw barrier:%d\n", State(obj));
    if (State(obj) == os_on){
        for (y = Lty(obj) ; y < Rby(obj) ; y+=GRID_SIZE){
            for (x = Ltx(obj) ; x < Rbx(obj) ; x+=GRID_SIZE){
                //                printf("draw img:(%d,%d)%d\n", x, y, obj->motion);
                draw_img(obj->motion, x, y);
            }
        }
	}
	return 0;
}


#ifdef DEBUG
void draw_hitmarker(void){
    int x, y;
    int r, g, b;
    puts("draw hitmarker");
    for (y = 0 ; y < MAP_HEIGHT ; y++){
        for (x = 0 ; x < MAP_WIDTH ; x++){
            if (emap[current_emap][y][x] == 0) continue;
            r = g = b = 128;
            if (CheckEMap(x, y, EM_BLOCK_UP)){
                b = 0;
            }
            if (CheckEMap(x, y, EM_BLOCK_DOWN)){
                b = 255;
            }
            if (CheckEMap(x, y, EM_BLOCK_LEFT)){
                g = 0;
            }
            if (CheckEMap(x, y, EM_BLOCK_RIGHT)){
                g = 255;
            }
            if (CheckEMap(x, y, EM_PUSH_LEFT)){
               g -= 100;
            }
            if (CheckEMap(x, y, EM_PUSH_RIGHT)){
               g += 100;
            }
            if (CheckEMap(x, y, EM_PUSH_UP)){
               b -= 100;
            }
            if (CheckEMap(x, y, EM_PUSH_DOWN)){
               b += 100;
            }
            if (CheckEMap(x, y, EM_PUSH_LEFTDOWN)){
                r = 255;
            }
            if (CheckEMap(x, y, EM_PUSH_RIGHTDOWN)){
                b = 255;
            }
            if (GetEMapOwner(x, y, _meat)){ g = 255; r = 0 ; b = 0;}
            if (CheckEMap(x, y, EM_WEIGHT)){
                r = 0; g = 0; b = 255;
            }
            if (CheckEMap(x, y, EM_FLAME)){
                r = 255; g = 0; b = 0;
            }
            if (CheckEMap(x, y, EM_TELEPORT)){
                r = 255; g = 255; b = 0;
            }

            //            if (CheckEMap(x, y, EM_BLOCK_LEFT)){
            //                r = 255; g = 255; b = 255;
            //            }



            //            printf("[%d, %d, %d]\n", r, g, b);
            EzSetColorByRGB(r, g, b);
            EzFillBoxB(DLTX(x), DLTY(y), DRBX(x), DRBY(y));
        }
    }
}
#endif
