#ifndef UTY_H
#define UTY_H
#include <stdlib.h>
#include "config.h"

// 上限付の加算値を返す
// 通常はv+aを返すが、結果がlimitを超える場合はlimitを返す
#define AddLimit(v, a, limit) (v+a > limit ? (v = limit) : (v += a))
// 上限付のインクリメントを行う
// 通常はv++と同じだが、v==limitのときはなにもしない
#define IncLimit(v, limit) (v+1 > limit ? v : (v)++)

#define MaxInt(x, y) ((x)>(y) ? x : y)

typedef enum {
    di_begin = 0,
    di_none = 0, di_up, di_right, di_down, di_left,
    di_end
} dir_t;

#define ReverseDir(dir) ((dir_t)((dir-1+2) % 4 + 1))

#endif
